#include <stdio.h>
#include <stdlib.h>

struct atomo {
       int dato;
       struct atomo *next;
       };
       
int test_lista_vuota(struct atomo *tlista)
{
    if(tlista==NULL)
       return 1;
    else return 0;
}


int testa_lista(struct atomo *tlista)
{ /* da invocare solo dopo avere verificato che la lista
    non e' vuota*/
    
    return (*tlista).dato;
    /* oppure 
    return tlista->dato;
    */
}

void in_lista(struct atomo **ptlista, int x)
{
     struct atomo *aux;
     
     /* creazione del nuovo elemento*/
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL)
      return;
     aux->dato=x;
     
     /* collegamento del nuovo elemento al vecchio
        primo elemento */
     aux->next=*ptlista;
     /* aggiornamento dell'indirizzo del primo elemento*/
     *ptlista=aux;
}


void da_lista(struct atomo **ptlista)
{
     struct atomo *aux;
     
     if(test_lista_vuota(*ptlista)==0)
     /* se la lista non e' vuota*/
     {
      /* memorizziamo l'indizizzo dell'elemento
        in testa da eliminare */
      aux=*ptlista;
      /* aggiorniamo l'indirizzo del primo elemento*/
      *ptlista=aux->next;
      /* liberiamo la memoria del vecchio primo elemento*/
      free(aux);
     }
   else printf("Lista vuota\n");
}

void visualizza(struct atomo *tlista)
{
     struct atomo *aux;
     
     aux=tlista;
     while(aux!=NULL)
     /* fino a quando non siamo arrivati
         alla fine della lista */
     { printf("%d\n",aux->dato);
       aux=aux->next;
     }
}

void elimina(struct atomo **ptlista)
{
     struct atomo *l1,*l2;
     int x;
     
     if(test_lista_vuota(*ptlista)==0)
     {  /* se la lista non e' vuota */
       printf("Elemento da eliminare: ");
       scanf("%d",&x);
       if((*ptlista)->dato==x)
        {  /* l'elemento e' in testa */
           da_lista(ptlista);
           return;
        }
       l2=*ptlista;   /* l2 punta al primo elemento */
       l1=l2->next; /* l1 punta al secondo elemento */
       while(l1!=NULL)
          if(l1->dato==x)  /* trovato */
            { /* eliminiamo */
              l2->next=l1->next;
              free(l1);
              return;
            }
          else {l2=l1;
                l1=l1->next;
                }
       /* si arriva in questo punto solo se l'elemento 
          non esiste e il puntatore l1 e' diventato NULL*/
       printf("L'elemento non e' presente\n");
      }
     else printf("Lista vuota\n");
}

void ins_ordinato(struct atomo **ptlista, int x)
{
     struct atomo *aux,*l1,*l2;
     
     if(test_lista_vuota(*ptlista)==1 )
         in_lista(ptlista,x);
     else if (x<(*ptlista)->dato)
          in_lista(ptlista,x);
          else { /* creamo il nuovo elemento */
                 aux=(struct atomo *) malloc(sizeof(struct atomo));
                 if(aux==NULL) 
                     return;
                 aux->dato=x;
                 /* cerchiamo la posizione dove inserire
                     il nuovo elemento */
                 l2=*ptlista;
                 l1=l2->next;
                 while(l1!=NULL)
                    if(x<l1->dato) /* trovato la posizione giusta*/
                        break;
                    else {l2=l1;
                          l1=l1->next;
                          }
                  l2->next=aux;
                  aux->next=l1;
                 }
               
                 
}  
     


       
                 
     




main() {

  struct atomo *tlista;
  int scelta,x;
  
  
  tlista=NULL;
  
  do {
   printf("Scegli tra\n");
   printf("1) test lista vuota\n");
   printf("2) testa lista\n");
   printf("3) inserimento ordinato\n");
   printf("4) eliminazione dalla testa\n");
   printf("5) visualizzazione lista\n");
   printf("6) Elimina un elemento x\n");
    
   printf("0) fine\n");
   scanf("%d",&scelta);
   switch(scelta) {
     case 1:  if(test_lista_vuota(tlista)==1)
                      printf("Lista vuota\n");
              else  printf("Lista non vuota\n");
              break;
     case 2:  if(test_lista_vuota(tlista)==0)
              /* se la lista non e' vuota*/
                 printf("%d\n",testa_lista(tlista));
              break;
     case 3:  printf("Elemento da inserire ");
              scanf("%d",&x);
              ins_ordinato(&tlista,x);
              break;
     case 4:  da_lista(&tlista);
              break;
     case 5:  visualizza(tlista);
              break;
     case 6:  elimina(&tlista);
              break;
     
     default:; }
  } while (scelta!=0);
  
  /* liberiamo la memoria occupata dalla lista*/
  while(tlista!=NULL)
    da_lista(&tlista);
}    
      
     
     
     
     



       
