#include <stdio.h>
#include <stdlib.h>

typedef struct {
        char autore[30],titolo[80];
        int codice,genere;
        }  libro;
        
        
struct atomo {
       libro dato;
       struct atomo *next;
       };
       
void in_lista(struct atomo **pl, libro x)
{
     struct atomo *aux;
     
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL)
         return;
     aux->dato=x;
     aux->next=*pl;
     *pl=aux;
}

void leggi(libro *p)
{
     printf("Autore: ");
     scanf("%s",p->autore);
     printf("Titolo: ");
     scanf("%s",p->titolo);
     printf("Codice identificativo: ");
     scanf("%d",&p->codice);
     printf("Genere (0..4): ");
     scanf("%d",&p->genere);
}

void ins_ordinato(struct atomo **pl, libro x)
{
    struct atomo *aux, *l1, *l2;
    
    if(*pl==NULL || x.codice <(*pl)->dato.codice )
        {
          in_lista(pl,x);
         return;
         }
    aux=(struct atomo *) malloc(sizeof(struct atomo));
    if(aux==NULL)
        return;
    aux->dato=x;
    
    l2=*pl;
    l1=l2->next;
    while(l1!=NULL)
      if(x.codice < l1->dato.codice)
            break;
      else {  l2=l1;
              l1=l1->next;
              }
    l2->next=aux;
    aux->next=l1;
}

void visualizza(struct atomo *pl)
{
     struct atomo *l;
     
     l=pl;
     while(l!=NULL)
      {   printf("Autore: %s\n",l->dato.autore);
          printf("Titolo: %s\n\n",l->dato.titolo);
          l=l->next;
      }
}


void elimina_lista(struct atomo **pl)
{
     struct atomo *aux;
     
     while(*pl!=NULL)
     /* fino a quando la lista non e' vuota */
     { /* elimino l'elemento in testa */
       aux=*pl;
       *pl=aux->next;
       free(aux);
     }
} 

main() {
       
  struct atomo *VL[5];
  libro l;
  int i,scelta;
  
  /* inizializziamo il vettore di liste*/
  for(i=0;i<5;i++)
     VL[i]=NULL;
  
  do {
      printf("Scegli tra\n");
      printf("1) Inserimento ordinato\n");
      printf("2) visualizzazione per genere\n");
      printf("0) fine\n\n");
      scanf("%d",&scelta);
      switch(scelta) {
      case 1:   /* inserimento ordinato */
                leggi(&l);
                i=l.genere;
                
                ins_ordinato(&VL[i],l);
                break;
      case 2:   /* visualizzazione */
                printf("Genere (0..4): ");
                scanf("%d",&i);
                visualizza(VL[i]);
                break;
      default:;
      }
      }  while(scelta!=0);
    
    for(i=0;i<5;i++)
       elimina_lista(&VL[i]);
}          
           
       
       
